1. Login to your server using putty
  2. Go to RubyForge and copy the URL of Redmine version you want to upgrade to.
  3. Download it to your server using wget command.
  4. Go to Redmine Site to check the requirements. Make sure you have all the required versions of gems installed. Please note that
    • Rails 2.3.5 will fail with RubyGems 1.5.0 and later, stick to previous versions of RubyGems
    • i18n 0.4.2 is required for Redmine >= 1.0.5 and i18n 0.4.2 require RubyGems 1.3.5 so
      You need to install a version of RubyGem between 1.3.5 and 1.4.2 for Redmine >=1.0.5
  5. Uncompress the newly downloaded program archive in a new directory.
  6. Copy your database settings-file config/database.yml into the new config directory.
  7. Copy your email settings-file config/email.yml into the new config directory.
  8. Copy the RAILS_ROOT/files directory content into your new installation.
  9. Copy the folders of your installed plugins into new installation directory
  10. Run the following command from your Redmine root directory:
    rake generate_session_store
  11. VERY IMPORTANT: do NOT overwrite config/settings.yml with the old one
  12. Go to your new redmine directory, then migrate your database:
    rake db:migrate RAILS_ENV=production
    If you have installed any plugins, you should also run their database migrations. 
    rake db:migrate_plugins RAILS_ENV=production 
  13. You should clear the cache and the existing sessions:
    rake tmp:cache:clear
    rake tmp:sessions:clear
  14. Check for any themes that you may have installed in the "public/themes" directory
  15. Restart the application server.
  16. Finally go to "Admin -> Roles & permissions" to check/set permissions for the new features, if any.

Source: http://www.redmine.org/projects/redmine/wiki/RedmineUpgrade